% variant 1: list of property pairs
% list of pairs: ([pos props], [neg props])->(pos.tree, neg.tree)
find_strategy_pairs(VT, Pairs, Trees) :-
	reset,
	marked_path_with_subnode_and_length(VT, VP, PLen),
	nb_getval(pathcount, PC),
	PC1 is PC + 1,
	nb_getval(verbose, V),
	(V=1 -> writef("\npath number: %w  |  path length: %w  |  ", [PC1,PLen]); true),
	nb_setval(pathcount, PC1),
	%retractall(usedpath(_)),
	%assert(usedpath(VP)),
	check_property_pairs(VP, Pairs, Trees),
	writeln('\nCheck successful (an attack found).\nTree(s) describing the regarding strategy is/are written to "Result_tree".'),
	!.
find_strategy_pairs(_,_,_) :-
	writeln('\nProperties could not be fulfilled (no attack found).'), !.


check_property_pairs(_, [], []) :- !.
check_property_pairs(VP, [(PosProps, NegProps)|RestPairs], [Tree|RestTrees]) :- % here: RestPairs \== []
    check_minimal(VP, PosProps, NegProps, Tree), !,
    check_property_pairs(VP, RestPairs, RestTrees).

find_strategy_pos(T, Pos, FinPos) :-
	check_minimal(T, Pos, [], ResultPos),
	get_mtree(ResultPos, FinPos), !.
find_strategy_neg(T, Neg, FinNeg) :-
	check_minimal(T, [], Neg, ResultNeg),
	get_mtree(ResultNeg, FinNeg), !.

% variant 2: one result tree
find_single_strategy_tree(VT, Pos, Neg, FinTree) :-
	reset,
	marked_path_with_subnode_and_length(VT, VP, PLen),
	nb_getval(pathcount, PC),
	PC1 is PC + 1,
	writef("\npath number: %w\tpath length: %w\n  ", [PC1,PLen]),
	nb_setval(pathcount, PC1),
	retractall(sucpath(_)),
	get_mtree(VP,MVP),
	assert(sucpath(MVP)),
	check_minimal(VP, Pos, Neg, ResTree),
	get_mtree(ResTree, FinTree),
	retractall(suctree(_)),
	assert(suctree(FinTree)),
	!.
% wrapper predicates
fsst(A,B,C,D) :- find_single_strategy_tree(A,B,C,D).
fsp(A,B,C) :- find_strategy_pairs(A,B,C).
